using System;
using System.Windows.Forms;
using System.Drawing;
using System.Globalization;
using Dbasic.EnhancedControls;
using System.Collections;
using System.IO;
using System.Text;
namespace Dbasic
{
public struct DDouble
	{
		double d;
		public DDouble(double d)
		{
			this.d = d;
		}
		public static double operator *(double a,DDouble b)
		{
			return Math.Pow(a,b);
		}   
		public static implicit operator double(DDouble m) 
		{
			return m.d;			
		}

	}
	public interface IStream
	{
		void Close();
		void Flush();
	}
	public interface IEnhancedControl
	{
		string propName
		{
			get;
		}
		 void AddRunTimeEvent(string eventName, string subName);
	}
	public class b4p
	{
		public static CultureInfo cul = new CultureInfo("en-US",false);
		public CEnhancedForm mainForm = null;
		public CEnhancedForm shownForm = null;
		public Color transColor = Color.Violet;
		public SolidBrush foreBrush = new SolidBrush(Color.Violet);
		public CEnhancedObject CEnhancedObject = null;
		public CaseInsensitiveComparer caseNotCompare; 
		public Comparer caseCompare;
		public CCompareNumbers numbersCompare;
		public bool quitFlag = false;
		public Hashtable htSubs = new Hashtable();
		public CHtControls htControls = new CHtControls();
		public delegate string del0();
        public delegate string del1(string a);
        public delegate string del2(string a,string b);
        public delegate string del3(string a,string b,string c);
		public ASCIIEncoding ae = new ASCIIEncoding();
		public string sender = "";
		public Hashtable htStreams = new Hashtable();
		private Other Other;
		private Object[] localVars = null;
		private Random rnd = new Random();
		public string dateFormat;
		public string timeFormat;
		public string b4pdir;
		public static string cPPC;
		public System.Threading.Thread tdRunning;
		public Exception lastError;
		public static double scaleX = 1;
        public static double scaleY = 1;
#if AUTOSCALE
		public static double fixX = 1;
        public static double fixY = 1;
#else
        public const double fixX = 1;
        public const double fixY = 1;
#endif
		public static bool autoScale = false;
		#if DESKTOP
		public ArrayList alFormsDisplayOrder = null;
		public int screenY = 268,screenX = 238;
		public string icon = "";
		#endif
		#if SIP
		private Microsoft.WindowsCE.Forms.InputPanel inputPanel = new Microsoft.WindowsCE.Forms.InputPanel();
		#endif
		#if DESKTOP
		[STAThread]
		static void Main(string[] args)
		{
			new b4p(args);
		}
		#endif
		#if DEVICE
		static void Main(string[] args)
		{
			new b4p(args);
		}
		#endif
		private void AddRuntimeEvent(string name, string eventName, string subName)
        {
            if (htControls[name] is IEnhancedControl)
                ((IEnhancedControl)htControls[name]).AddRunTimeEvent(eventName, subName);
            else
                CEnhancedObject.AddRunTimeEvent(htControls[name],name, eventName,subName);
        }
		public bool CompareEqual(string lSide,string rSide)
		{
				if ((lSide == "" && rSide == "0") || (lSide == "0" && rSide == ""))
					return true;
				else
					return (lSide == rSide);
		}
		public bool LCompareEqual(string lSide,string rSide)
		{
				if (lSide == "" && rSide == "0")
					return true;
				else
					return (lSide == rSide);
		}
		public bool RCompareEqual(string lSide,string rSide)
		{
				if (lSide == "0" && rSide == "")
					return true;
				else
					return (lSide == rSide);
		}
		
		public bool ShowError(Exception ex, string subName)
        {
            Cursor.Current = Cursors.Default;
            if (this.quitFlag == true)
                return true;
            else
            {
                ArrayList alTimers = new ArrayList();
                foreach (DictionaryEntry d in this.htControls)
                {
                    object wc = d.Value;
                    if (wc is Timer &&
                        ((Timer)wc).Enabled == true)
                    {
                        ((Timer)wc).Enabled = false;
                        alTimers.Add(wc);
                    }
                }
                if (MessageBox.Show("An error occurred on sub " + subName +
                    ".\r\n\r\n"
                    + ex.Message + "\r\nContinue?", "Basic4ppc"
                    , MessageBoxButtons.YesNo, MessageBoxIcon.Hand, MessageBoxDefaultButton.Button1)
                    == DialogResult.No)
                {
                    this.quitFlag = true;
                    if (this.mainForm != null)
                        this.mainForm.Close();
                    return true;
                }
                else
                {
                    foreach (Timer timer in alTimers)
                        timer.Enabled = true;
                    return false;
                }

            }
        }
		public void CloseProgram()
        {
			this.quitFlag = true;
			shownForm = null;
            if (CEnhancedObject.htShemotAzamim != null)
                CEnhancedObject.htShemotAzamim.Clear();
            foreach (DictionaryEntry d in this.htStreams)
            {
                ((IStream)d.Value).Close();
            }
            this.htStreams.Clear();
            foreach (DictionaryEntry d in this.htControls)
            {
                object o = d.Value;
                if (o is CEnhancedForm && o != this.mainForm)
                    ((CEnhancedForm)o).Close();
                else if (o is Timer)
                {
                    ((Timer)o).Enabled = false;
                }
				try
                {
                    if (o != null && o is IDisposable)
                        ((IDisposable)o).Dispose();
                }
                catch
				{
				}
               
            }
            this.htControls.Clear();
            GC.Collect();
			#if DESKTOP
				Application.ExitThread();
			#endif
			#if DEVICE
				//MessageBox.Show("Closing");
			#endif

            Cursor.Current = Cursors.Default;
        }
		public b4p(string[] args)
		{
			try
			{
			CEnhancedObject = new CEnhancedObject(this);
			Other = new Other(this);
			dateFormat = "MM/dd/yyyy";
			timeFormat = "HH:mm";
			this.tdRunning = System.Threading.Thread.CurrentThread;
			#if DESKTOP
				b4pdir = System.Windows.Forms.Application.StartupPath;
				cPPC = "false";
				alFormsDisplayOrder = new ArrayList();
			#endif
			#if DEVICE
				b4pdir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
				cPPC = "true";
                if (b4pdir.StartsWith("file:\\"))
                {
					b4pdir = b4pdir.Remove(0,6);
                    if (System.Environment.OSVersion.Platform != PlatformID.WinCE)
                        cPPC = "false";
                }

			#endif
                System.Threading.Thread.SetData(System.Threading.Thread.GetNamedDataSlot("cPPC"), bool.Parse(cPPC));
                System.Threading.Thread.SetData(System.Threading.Thread.GetNamedDataSlot("optimized"), true);
                System.Threading.Thread.SetData(System.Threading.Thread.GetNamedDataSlot("b4p"), this);
			
			try
			{
				initialize();
			}
			catch (Exception ex)
			{
			MessageBox.Show("Error!\n" + ex.Message + "\n" + ex.StackTrace,"Basic4ppc");
			}